// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.
// See the LICENSE file in the project root for more information.

namespace System.Drawing
{
    public static class SystemColors
    {
        public static Color ActiveBorder => ColorUtil.FromKnownColor(KnownColor.ActiveBorder);
        public static Color ActiveCaption => ColorUtil.FromKnownColor(KnownColor.ActiveCaption);
        public static Color ActiveCaptionText => ColorUtil.FromKnownColor(KnownColor.ActiveCaptionText);
        public static Color AppWorkspace => ColorUtil.FromKnownColor(KnownColor.AppWorkspace);

        public static Color ButtonFace => ColorUtil.FromKnownColor(KnownColor.ButtonFace);
        public static Color ButtonHighlight => ColorUtil.FromKnownColor(KnownColor.ButtonHighlight);
        public static Color ButtonShadow => ColorUtil.FromKnownColor(KnownColor.ButtonShadow);

        public static Color Control => ColorUtil.FromKnownColor(KnownColor.Control);
        public static Color ControlDark => ColorUtil.FromKnownColor(KnownColor.ControlDark);
        public static Color ControlDarkDark => ColorUtil.FromKnownColor(KnownColor.ControlDarkDark);
        public static Color ControlLight => ColorUtil.FromKnownColor(KnownColor.ControlLight);
        public static Color ControlLightLight => ColorUtil.FromKnownColor(KnownColor.ControlLightLight);
        public static Color ControlText => ColorUtil.FromKnownColor(KnownColor.ControlText);

        public static Color Desktop => ColorUtil.FromKnownColor(KnownColor.Desktop);

        public static Color GradientActiveCaption => ColorUtil.FromKnownColor(KnownColor.GradientActiveCaption);
        public static Color GradientInactiveCaption => ColorUtil.FromKnownColor(KnownColor.GradientInactiveCaption);
        public static Color GrayText => ColorUtil.FromKnownColor(KnownColor.GrayText);

        public static Color Highlight => ColorUtil.FromKnownColor(KnownColor.Highlight);
        public static Color HighlightText => ColorUtil.FromKnownColor(KnownColor.HighlightText);
        public static Color HotTrack => ColorUtil.FromKnownColor(KnownColor.HotTrack);

        public static Color InactiveBorder => ColorUtil.FromKnownColor(KnownColor.InactiveBorder);
        public static Color InactiveCaption => ColorUtil.FromKnownColor(KnownColor.InactiveCaption);
        public static Color InactiveCaptionText => ColorUtil.FromKnownColor(KnownColor.InactiveCaptionText);
        public static Color Info => ColorUtil.FromKnownColor(KnownColor.Info);
        public static Color InfoText => ColorUtil.FromKnownColor(KnownColor.InfoText);

        public static Color Menu => ColorUtil.FromKnownColor(KnownColor.Menu);
        public static Color MenuBar => ColorUtil.FromKnownColor(KnownColor.MenuBar);
        public static Color MenuHighlight => ColorUtil.FromKnownColor(KnownColor.MenuHighlight);
        public static Color MenuText => ColorUtil.FromKnownColor(KnownColor.MenuText);

        public static Color ScrollBar => ColorUtil.FromKnownColor(KnownColor.ScrollBar);

        public static Color Window => ColorUtil.FromKnownColor(KnownColor.Window);
        public static Color WindowFrame => ColorUtil.FromKnownColor(KnownColor.WindowFrame);
        public static Color WindowText => ColorUtil.FromKnownColor(KnownColor.WindowText);
    }
}
